-- | Contains some typesafe operations on DRT structures.
module ELCS.DRT.Typesafe (
  typesafe
, isWellTyped
, mkAppT
) where

import ELCS.MR.Label
import ELCS.DRT.AST
import ELCS.DRT.TypeInference
import ELCS.Util

typesafe :: DRT -> DRT
typesafe e =
  case inferTypes e of
    Left msg -> assertMsg msg False e
    Right e' -> e'
    
isWellTyped :: DRT -> Bool
isWellTyped e =
  case inferTypes e of
    Left _msg -> False
    Right _e' -> True
 
mkAppT :: MRLabel -> DRT -> DRT -> DRT
mkAppT l v = typesafe . mkAppRenaming l v
