{-# LANGUAGE MultiParamTypeClasses, FlexibleInstances #-}

module ELCS.LambdaLike where

import ELCS.MR
import ELCS.MR.Label
import qualified ELCS.DRT as DRT

-- Meaning representations that implement some form of lambda calculus, i.e. that know
-- abstractions, applications, and variable expressions.
class (MR a) => LambdaLike a where
  mkAbs :: MRLabel -> Var -> a -> a
  mkApp :: MRLabel -> a -> a -> a
  mkVExp :: MRLabel -> Var -> a

instance LambdaLike DRT.DRT where
  mkVExp = DRT.mkVExp
  mkAbs = DRT.mkAbs
  mkApp = DRT.mkApp

