{-# LANGUAGE DeriveDataTypeable, DeriveGeneric, DefaultSignatures #-}

module ELCS.MR.Label(
  MRLabel(..)
, emptyMRLabel
, alignmentMRLabel
, unalignedMRLabel
) where

import ELCS.MR.Type

import Control.DeepSeq (NFData(..))
import GHC.Generics(Generic)


data MRLabel = MRLabel { mrLabelAlignment :: Maybe [Int]
                       , mrLabelType :: Maybe Type }
               deriving (Show, Eq, Ord, Read, Generic)
               
emptyMRLabel :: MRLabel
emptyMRLabel = MRLabel { mrLabelAlignment = Nothing
                       , mrLabelType = Nothing }

alignmentMRLabel :: [Int] -> MRLabel
alignmentMRLabel al = emptyMRLabel { mrLabelAlignment = Just al }
                       
-- | A label that specifies an empty set of alignment edges and no other annotations.
unalignedMRLabel :: MRLabel
unalignedMRLabel = alignmentMRLabel []

instance NFData MRLabel where
  rnf l = rnf (mrLabelAlignment l) `seq`
          rnf (mrLabelType l)

