{-| The main module for the ELCS executable.
    
    This file simply dispatches to the appropriate sub-command.
-}
module Main where

import ELCS.Main.Common.CLOptions
import qualified ELCS.Main.Extract as Extract
import qualified ELCS.Main.WriteDefaultConfig as WriteDefaultConfig
import qualified ELCS.Main.Collate as Collate
import qualified ELCS.Main.SentenceStats as SentenceStats
import qualified ELCS.Main.GrammarToHtml as GrammarToHtml

-- | The main function. It uses 'ELCS.Main.Common.CLOptions' to process the command line arguments
--   and then calls the appropriate sub-command’s "mainWith" function.
main :: IO ()
main =
  do
    opts <- parseOptions
    case opts of
      Extract o -> Extract.mainWith o
      WriteDefaultConfig o -> WriteDefaultConfig.mainWith o
      Collate o -> Collate.mainWith o
      CmdSentenceStats o -> SentenceStats.mainWith o
      CmdGrammarToHtml o -> GrammarToHtml.mainWith o


