# Download and extract the Groningen Meaning Bank
wget http://gmb.let.rug.nl/releases/gmb-2.1.0.zip
unzip gmb-2.1.0.zip

# Make sure we get current packages from Hackage
cabal update

# Comment this if you’re using an old cabal-install without sandbox support
cabal sandbox init

# Install library dependencies
cabal install --only-dependencies -j

# Generate a config file
cabal run -- WriteDefaultConfig
mv elcs-extract.config.default elcs-extract.config

# Extract sentence grammars for the first few documents of the GMB
# Insert your number of processor cores instead of -N4
cabal run -- Extract --gmb gmb-2.1.0/ --docs=p00d0000..p00d0099 +RTS -N4

# Combine the extracted grammars into a complete CCG
cabal run -- Collate grammar/*.g.gz

# View the extracted grammar
gunzip -c out.g.gz | less
